<?php
// Basic setup of phpBB variables.
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

// Load include files.
include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup();

$error_log = array();

$sql_array = array(
    'field_id'              => 1,
    'field_name'            => 'show_on_map',
    'field_type'            => 4,
    'field_ident'           => 'show_on_map',
    'field_length'          => '2',
    'field_minlen'          => '0',
    'field_maxlen'          => '0',
    'field_novalue'         => '0',
    'field_default_value'   => '1',
    'field_validation'      => '',
    'field_required'        => 0,
    'field_show_on_reg'     => 1,
    'field_show_on_vt'      => 0,
    'field_show_profile'    => 1,
    'field_hide'            => 0,
    'field_no_view'         => 0,
    'field_active'          => 1,
    'field_order'           => 1,
);

$sql = 'INSERT INTO ' . PROFILE_FIELDS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_array);

if(!$db->sql_query($sql))
{
    $error_log[PROFILE_FIELDS_TABLE . ' SQL Failure'] = 'The following SQL failed: ' . $sql;
}

$field_id = $db->sql_nextid();

$sql_array = array(
    'field_id'              => $field_id,
    'lang_id'               => 1,
    'lang_name'             => 'Show On Map',
    'lang_explain'          => 'Show me on Google Earth',
    'lang_default_value'    => '',
);

$sql = 'INSERT INTO ' . PROFILE_LANG_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_array);

if(!$db->sql_query($sql))
{
    $error_log[PROFILE_LANG_TABLE . ' SQL Failure'] = 'The following SQL failed: ' . $sql;
}

$sql_array = array(
    array(
        'field_id'              => $field_id,
        'lang_id'               => 1,
        'option_id'             => 0,
        'field_type'            => 4,
        'lang_value'            => 'Yes',
    ),

    array(
        'field_id'              => $field_id,
        'lang_id'               => 1,
        'option_id'             => 1,
        'field_type'            => 4,
        'lang_value'            => 'No',
    ),
);

if(!$db->sql_multi_insert(PROFILE_FIELDS_LANG_TABLE, $sql_array))
{
    $error_log[PROFILE_FIELDS_LANG_TABLE . ' SQL Failure'] = 'The following SQL failed: ' . $sql;
}

$sql = 'ALTER TABLE ' . PROFILE_FIELDS_DATA_TABLE . ' ADD COLUMN pf_show_on_map tinyint(2)';

if(!$db->sql_query($sql))
{
    $error_log[PROFILE_FIELDS_DATA_TABLE . ' SQL Failure'] = 'The following SQL failed: ' . $sql;
}

if(sizeof($error_log) > 0)
{
    $error_msg = "The following errors occurred:
                    <ul>";

    foreach($error_log as $key => $value)
    {
        $error_msg .= "<li>" . $key . " - " . $value . "</li>";
    }

    $error_msg .= "</ul>";

    trigger_error($error_msg, E_USER_ERROR);
}
else
{
    trigger_error("Installation Success!", E_USER_NOTICE);
}
?>