<?php
header("Content-Type:text/xml");

// Basic setup of phpBB variables.
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

// Load include files.
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
include("GeoCity/geoipcity.inc");
include("GeoCity/geoipregionvars.php");

$user->session_begin();
$auth->acl($user->data);
$user->setup();
$user->add_lang('mods/info_earthmapper');
$mode = request_var('mode', '');

switch ($mode)
{
    case 'users':

        $sql_array = array(
            'SELECT'    => 'imageset_path',
            'FROM'      => array(STYLES_IMAGESET_TABLE => 's'),
            'LEFT_JOIN' => array(
                array(
                    'FROM'  => array(USERS_TABLE => 'u'),
                    'ON'    => 's.imageset_id = u.user_style',
                ),
            ),
            'WHERE'     => 's.imageset_id=' . $user->data['user_style'],
        );

        $sql = $db->sql_build_query('SELECT', $sql_array);

        $result = $db->sql_query($sql);

        $style_name = $db->sql_fetchfield('imageset_path');

        $db->sql_freeresult($result);

        $sql_array = array(
            'SELECT'    => '*',
            'FROM'      => array(USERS_TABLE => 'u'),
            'LEFT_JOIN' => array(
                array(
                    'FROM'  => array(PROFILE_FIELDS_DATA_TABLE => 'p'),
                    'ON'    => 'p.user_id = u.user_id',
                ),
            ),
            'WHERE'     => 'pf_show_on_map=1',
        );

        $sql = $db->sql_build_query('SELECT', $sql_array);

        $result = $db->sql_query($sql);


        $placemarks = array();

        $gi = geoip_open("data/GeoLiteCity.dat", GEOIP_STANDARD);

        while ($row = $db->sql_fetchrow($result))
        {
            $record = geoip_record_by_addr($gi,$row['user_ip']);

            if($record->city != '')
            {
                $avatar_path = '';

                switch($row['user_avatar_type'])
                {
                    case AVATAR_UPLOAD:
                        $avatar_path = generate_board_url() . '/download/file.php?avatar=' . $row['user_avatar'];
                        break;

                    case AVATAR_REMOTE:
                        $avatar_path = $row['user_avatar'];
                        break;

                    case AVATAR_GALLERY:
                        $avatar_path = generate_board_url() . '/download/file.php?avatar=' . $row['user_avatar'];
                        break;

                    default:
                        $avatar_path = generate_board_url() . '/styles/' . $style_name . '/theme/images/no_avatar.gif';
                }

                get_user_rank($row['user_rank'], (($row['user_id'] == ANONYMOUS) ? false : $row['user_posts']), $rank_title, $rank_img, $rank_img_src);

                $sql = 'SELECT COUNT(u.user_id) as u_count
                        FROM ' . USERS_TABLE . ' u, ' . SESSIONS_TABLE . ' s
                        WHERE u.user_id = s.session_user_id
                        AND s.session_time >= ' . (time() - ($config['load_online_time'] * 60)) . '
                        AND u.user_id=' . $row['user_id'];

                $result1 = $db->sql_query($sql);

                $online = (int)$db->sql_fetchfield('u_count');

                $placemarks[$row['user_id']] = "<Style id='{$row['user_id']}'>
                                                    <IconStyle>
                                                        <color>ffffffff</color>
                                                        <colorMode>normal</colorMode>
                                                        <scale>1</scale>
                                                        <Icon>
                                                            <href>" . $avatar_path . "</href>
                                                        </Icon>
                                                    </IconStyle>
                                                </Style>
                                                <Placemark>
                                                    <name>{$row['username']}</name>
                                                    <description><![CDATA["
                                                    . get_username_string('full', $row['user_id'], $row['username'])
                                                    . '<br />'
                                                    . str_replace('..', generate_board_url(), get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']))
                                                    . '<br />'
                                                    .  '<img src="' . str_replace('..', generate_board_url(), $rank_img_src) . '"/>'
                                                    . '<br />'
                                                    . '<strong>' . $user->lang['JOINED'] . ': </strong>' . $user->format_date($row['user_regdate'])
                                                    . '<br />'
                                                    . '<strong>' . $user->lang['VISITED'] . ': </strong>' . $user->format_date($row['user_lastvisit'])
                                                    . '<br />'
                                                    . '<strong>' . $user->lang['TOTAL_POSTS'] . ': </strong>' . $row['user_posts']
                                                    . "]]></description>
                                                    <styleUrl>#{$row['user_id']}</styleUrl>
                                                    <Point>
                                                        <coordinates>{$record->longitude},{$record->latitude}</coordinates>
                                                    </Point>
                                               </Placemark>";
            }
        }

        echo '<?xml version="1.0" encoding="UTF-8"?>';
        echo '<kml xmlns="http://www.opengis.net/kml/2.2">';

        echo '<Document>';

        echo implode('\n', $placemarks);

        echo '</Document>';

        echo '</kml>';

        break;

    case 'friends':

        $sql_array = array(
            'SELECT'    => '*',
            'FROM'      => array(USERS_TABLE => 'u'),
            'LEFT_JOIN' => array(
                array(
                    'FROM'  => array(ZEBRA_TABLE => 'z'),
                    'ON'    => 'u.user_id = z.user_id',
                ),
                array(
                    'FROM'  => array(PROFILE_FIELDS_DATA_TABLE => 'p'),
                    'ON'    => 'u.user_id=p.user_id'
                )
            ),

            'WHERE'     => 'u.user_id=' . $user->data['user_id'] . ' AND z.friend=1 AND p.pf_show_on_map',
        );


        $sql = $db->sql_build_query('SELECT', $sql_array);

        $result = $db->sql_query($sql);

        $placemarks = array();

        $gi = geoip_open("data/GeoLiteCity.dat", GEOIP_STANDARD);

        while ($row = $db->sql_fetchrow($result))
        {
            $record = geoip_record_by_addr($gi,$row['user_ip']);

            if($record->city != '')
            {
                $avatar_path = '';

                switch($row['user_avatar_type'])
                {
                    case AVATAR_UPLOAD:
                        $avatar_path = generate_board_url() . '/download/file.php?avatar=' . $row['user_avatar'];
                        break;

                    case AVATAR_REMOTE:
                        $avatar_path = $row['user_avatar'];
                        break;

                    case AVATAR_GALLERY:
                        $avatar_path = generate_board_url() . '/download/file.php?avatar=' . $row['user_avatar'];
                        break;
                }
                $placemarks[$row['user_id']] = "<Style id='{$row['user_id']}'>
                                                    <IconStyle>
                                                        <color>ffffffff</color>
                                                        <colorMode>normal</colorMode>
                                                        <scale>1</scale>
                                                        <Icon>
                                                            <href>" . $avatar_path . "</href>
                                                        </Icon>
                                                    </IconStyle>
                                                </Style>
                                                <Placemark>
                                                    <name>{$row['username']}</name>
                                                    <description><![CDATA["
                                                    . get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']) .
                                                    "]]></description>
                                                    <styleUrl>#{$row['user_id']}</styleUrl>
                                                    <Point>
                                                        <coordinates>{$record->longitude},{$record->latitude}</coordinates>
                                                    </Point>
                                               </Placemark>";
            }
        }

        echo '<?xml version="1.0" encoding="UTF-8"?>';
        echo '<kml xmlns="http://www.opengis.net/kml/2.2">';

        echo '<Document>';

        echo implode('\n', $placemarks);

        echo '</Document>';

        echo '</kml>';

        break;

    case 'online':

        $sql = 'SELECT u.*, s.session_id, s.session_time, s.session_page, s.session_ip, s.session_browser, s.session_viewonline, s.session_forum_id
	FROM ' . USERS_TABLE . ' u, ' . SESSIONS_TABLE . ' s,
         ' . PROFILE_FIELDS_DATA_TABLE . ' p
	WHERE u.user_id = s.session_user_id AND p.pf_show_on_map=1
		AND s.session_time >= ' . (time() - ($config['load_online_time'] * 60));

        $result = $db->sql_query($sql);


        $placemarks = array();

        $gi = geoip_open("data/GeoLiteCity.dat", GEOIP_STANDARD);

        while ($row = $db->sql_fetchrow($result))
        {
            $record = geoip_record_by_addr($gi,$row['user_ip']);

            if($record->city != '')
            {
                $avatar_path = '';

                switch($row['user_avatar_type'])
                {
                    case AVATAR_UPLOAD:
                        $avatar_path = generate_board_url() . '/download/file.php?avatar=' . $row['user_avatar'];
                        break;

                    case AVATAR_REMOTE:
                        $avatar_path = $row['user_avatar'];
                        break;

                    case AVATAR_GALLERY:
                        $avatar_path = generate_board_url() . '/download/file.php?avatar=' . $row['user_avatar'];
                        break;
                }

                get_user_rank($row['user_rank'], (($row['user_id'] == ANONYMOUS) ? false : $row['user_posts']), $rank_title, $rank_img, $rank_img_src);

                $placemarks[$row['user_id']] = "<Style id='{$row['user_id']}'>
                                                    <IconStyle>
                                                        <color>ffffffff</color>
                                                        <colorMode>normal</colorMode>
                                                        <scale>1</scale>
                                                        <Icon>
                                                            <href>" . $avatar_path . "</href>
                                                        </Icon>
                                                    </IconStyle>
                                                </Style>
                                                <Placemark>
                                                    <name>{$row['username']}</name>
                                                    <description><![CDATA["
                                                    . get_username_string('full', $row['user_id'], $row['username'])
                                                    . '<br />'
                                                    . get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height'])
                                                    . '<br />'
                                                    . $rank_img
                                                    . '<br />'
                                                    . '<strong>' . $user->lang['JOINED'] . ': </strong>' . $user->format_date($row['user_regdate'])
                                                    . '<br />'
                                                    . '<strong>' . $user->lang['VISITED'] . ': </strong>' . $user->format_date($row['user_lastvisit'])
                                                    . '<br />'
                                                    . '<strong>' . $user->lang['TOTAL_POSTS'] . ': </strong>' . $row['user_posts']
                                                    . "]]></description>
                                                    <styleUrl>#{$row['user_id']}</styleUrl>
                                                    <Point>
                                                        <coordinates>{$record->longitude},{$record->latitude}</coordinates>
                                                    </Point>
                                               </Placemark>";
            }
        }

        echo '<?xml version="1.0" encoding="UTF-8"?>';
        echo '<kml xmlns="http://www.opengis.net/kml/2.2">';

        echo '<Document>';

        echo implode('\n', $placemarks);

        echo '</Document>';

        echo '</kml>';

        break;

    case 'standard':
    default:

        $gi = geoip_open("data/GeoLiteCity.dat",GEOIP_STANDARD);

        $sql = "SELECT *"
                . " FROM " . GOOGLE_CUSTOM_PLACEMARKS;

        $result = $db->sql_query($sql);
        $placemarks = array();
        $placemark_styles = array();

        while($row = $db->sql_fetchrow($result))
        {
            $placemarks[$row['id']] = "<Placemark>\n
                                        <name>{$row['label']}</name>\n
                                        <Point>
                                            <coordinates>{$row['lng']},{$row['lat']}</coordinates>\n
                                        </Point>\n";
            if($row['icon_path'] != NULL)
            {
                $placemarks[$row['id']] .= "<styleUrl>#customPlacemark{$row['id']}</styleUrl>\n";

            }

            $placemarks[$row['id']] .= "</Placemark>\n";

            if($row['icon_path'] != NULL)
            {
                $placemark_styles[] = "<Style id=\"customPlacemark{$row['id']}\">\n
                                        <IconStyle>\n
                                          <scale>{$row['icon_scale']}</scale>\n
                                          <Icon>\n
                                            <href>{$row['icon_path']}</href>\n
                                          </Icon>\n
                                        </IconStyle>\n
                                       </Style>\n";
            }
        }

        $sql = "SELECT user_ip" .
                        " FROM " . USERS_TABLE .
                        " WHERE NOT user_ip = ''"
                        . " ORDER BY user_ip";

        $result = $db->sql_query($sql);
        $cities = array();

        while($row = $db->sql_fetchrow($result))
        {
                $record = geoip_record_by_addr($gi,$row['user_ip']);
                //echo $record->city . "\n";
                if($record->city != '')
                {
                        if(!array_key_exists($record->city, $cities))
                        {
                                $cities[$record->city] = array();
                        }

                        $cities[$record->city]['name'] = $record->city;

                        $cities[$record->city]['count'] += 1;

                        $cities[$record->city]['lat'] = $record->latitude;

                        $cities[$record->city]['long'] = $record->longitude;
                }

        }


        foreach($cities as $city)
        {
                $output .= '<Placemark>';
                $output .= build_name($city['name'], $city['count']);
                $output .= '<Point>';
                $output .= "<coordinates>{$city['long']},{$city['lat']}</coordinates>";
                $output .= '</Point>';
                $output .= '<styleUrl>#customPlacemark</styleUrl>';
                $output .= '</Placemark>';

        }

        echo '<?xml version="1.0" encoding="UTF-8"?>';
        echo '<kml xmlns="http://www.opengis.net/kml/2.2">';

        echo '<Document>';

        echo implode("\n", $placemark_styles);

        if((isset($config['earthmapper_icon_path'])) && (!empty($config['earthmapper_icon_path'])))
        {
                echo '<Style id="customPlacemark">
            <IconStyle>
              <scale>1.399999976158142</scale>
              <Icon>
                <href>' . $config['earthmapper_icon_path'] . '</href>
              </Icon>
            </IconStyle>
          </Style>';
        }

        echo implode("\n", $placemarks);

        echo $output;

        echo '</Document>';

        echo '</kml>';
}
geoip_close($gi);

function build_name($city_name, $user_count)
{
	global $config;
	if((isset($config['earthmapper_placemark_text'])) && (!empty($config['earthmapper_placemark_text'])))
	{
		$placemark_text = '<name>' . $config['earthmapper_placemark_text'] . '</name>';


		if((!strpos($placemark_text, '%s')) && (strpos($placemark_text, '%d')))
		{
			//echo 'We want numbers not cities';
			$placemark_text = sprintf($placemark_text, $user_count);
		}
		elseif((strpos($placemark_text, '%s')) && (!strpos($placemark_text, '%d')))
		{
			//echo 'We want cities not numbers';
			$placemark_text = sprintf($placemark_text, $city_name);
		}
		else
		{
			//echo 'We want both';
			if((strpos($placemark_text, '%s')) < (strpos($placemark_text, '%d')))
			{
				//echo 'Cities before numbers';
				$placemark_text = sprintf($placemark_text, $city_name, $user_count);
			}
			else
			{
				//echo 'Numbers before cities';
				$placemark_text = sprintf($placemark_text, $user_count, $city_name);
			}
		}

	}
	else
	{
		$placemark_text = sprintf("<name>%s: %d users</name>", $city_name, $user_count);
	}

	return $placemark_text;
}
?>