<?php
/**
*
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if (!defined('IN_PHPBB'))
{
	exit;
}


class acp_earthmapper
{
	var $u_action;
	var $p_master;

	function acp_users(&$p_master)
	{
		$this->p_master = &$p_master;
	}

	function main($id, $mode)
	{
		global $config, $db, $user, $template;
		global $phpbb_root_path, $phpEx;

		
		// Set the template details.
		$this->tpl_name = 'acp_earthmapper';
		$this->page_title = 'ACP_EARTHMAPPER';
		
		// Retrieve the action and submit values.
		$action		= request_var('action', '');
                $form_type      = request_var('form_name', '');

		$submit		= isset($_POST['submit']) ? true : false;

		// Set the form name and add the form key.
		$form_name = 'acp_earthmapper';
		add_form_key($form_name);
		
		
		// Process the submit action.
		if($submit)
		{
                    if($form_type == "settings")
                    {
			$google_maps_key	= request_var('google_maps_key', '');
			$icon_path              = request_var('icon_path', '');
			$placemark_text		= request_var('placemark_text', '');
                        
			set_config('earthmapper_google_maps_key', $google_maps_key, true);
			set_config('earthmapper_icon_path', $icon_path, true);
			set_config('earthmapper_placemark_text', $placemark_text, true);
                        
			trigger_error($user->lang['ACP_EM_OPTIONS_SAVED'] . adm_back_link($this->u_action));
                    }

                    if($form_type == "placemarks")
                    {
                        $placemark_label	= request_var('placemark_label', '');
                        $lat                    = request_var('lat', '');
                        $long           	= request_var('long', '');
                        $icon_path              = request_var('placemark_icon', '');
                        $icon_scale             = (int)request_var('placemark_scale', 1);

                        if($icon_path == "")
                        {
                            $sql = "INSERT INTO " . GOOGLE_CUSTOM_PLACEMARKS . "(label, lat, lng)"
                                    . " VALUES('$placemark_label', '$lat', '$long')";
                        }
                        else
                        {
                            $sql = "INSERT INTO " . GOOGLE_CUSTOM_PLACEMARKS . "(label, lat, lng, icon_path, icon_scale)"
                                    . " VALUES('$placemark_label', '$lat', '$long', '$icon_path', '$icon_scale')";
                        }
                        $result = $db->sql_query($sql);

                        if(!$result)
                        {
                            trigger_error($user->lang['ACP_EM_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
                        }
                        else
                        {
                            trigger_error($user->lang['ACP_EM_PLACEMARK_SAVED'] . adm_back_link($this->u_action));
                        }
                    }
		}
                else
                {
                    $placemark_id = request_var('placemark_id', '');


                    switch($action)
                    {
                        case 'delete':

                            $sql = "DELETE FROM " . GOOGLE_CUSTOM_PLACEMARKS . " WHERE id = '{$placemark_id}'";
                            
                            $result = $db->sql_query($sql);

                            if(!$result)
                            {
                                trigger_error($user->lang['ACP_EM_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
                            }
                            else
                            {
                                trigger_error($user->lang['ACP_EM_PLACEMARK_DELETED'] . adm_back_link($this->u_action));
                            }
                            break;
                    }
                }

                $sql = "SELECT *" .
                        " FROM " . GOOGLE_CUSTOM_PLACEMARKS;

                $result = $db->sql_query($sql);

                while($row = $db->sql_fetchrow($result))
                {
                    $template->assign_block_vars('placemarks', array(
                                                    'LABEL'	=> $row['label'],
                                                    'COORDS'	=> $row['lat'] . "," . $row['lng'],
                                                    'ICON'	=> $row['icon_path'],
                                                    'SCALE'	=> $row['icon_scale'],
                                                    'U_DELETE'	=> $this->u_action . "&amp;action=delete&amp;placemark_id={$row['id']}")
						);
                }

                
				
		$template->assign_vars(array(
			'GOOGLE_MAPS_KEY'			=> $config['earthmapper_google_maps_key'],
			'KML_PATH'				=> $config['earthmapper_kml'],
			'ICON_PATH'				=> $config['earthmapper_icon_path'],
			'PLACEMARK_TEXT'			=> $config['earthmapper_placemark_text'],
			'U_ACTION'				=> $this->u_action,
		));
	}
	
}

?>